/**************************************************************
  (C) 1997 by Achim Kaiser

  You may distribute under the terms of the GNU General Public
  License as specified in the COPYING file.
**************************************************************/

#include <Xlib.h>
#include <Xutil.h>
#include <malloc.h>
#include "global.h"
#include "color.h"

void InitColors()
{
  Colormap cmap;
  XColor pixs[MAXCOLORS];
  XColor pix;
  unsigned long a;
  if (XDefaultVisual(GetDisplay(),XDefaultScreen(GetDisplay()))->class==PseudoColor) {
    cmap=XDefaultColormap(GetDisplay(),XDefaultScreen(GetDisplay()));
    a=0;
    do {
      pix.red=9362*(224&a)/32;
      pix.green=9362*(28&a)/4;
      pix.blue=21845*(3&a);
      if(XAllocColor(GetDisplay(),cmap,&pix)==0)
	a=255;
      a++;
    } while (pix.pixel<MAXCOLORS);
    if (a<256)
      XFreeColors(GetDisplay(),cmap,&pix.pixel,1,0);
    for (a=0;a<MAXCOLORS;a++) 
      pixs[a].pixel=a;
    XQueryColors(GetDisplay(),cmap,pixs,MAXCOLORS);
    for (a=0;a<MAXCOLORS;a++)
      XAllocColor(GetDisplay(),cmap,&pixs[a]);
  }
}

unsigned long GetBestColor(int r,int g,int b)
{    
  Colormap cmap;
  XColor backcolor;
  static XColor *pixcolors=NULL;
  long difference,localdifference;
  int i;
  unsigned long bg=0;
  backcolor.red=r;
  backcolor.green=g;
  backcolor.blue=b;
  cmap=XDefaultColormap(GetDisplay(),XDefaultScreen(GetDisplay()));
  
  if (XDefaultVisual(GetDisplay(),XDefaultScreen(GetDisplay()))->class!=PseudoColor && 
      XAllocColor(GetDisplay(),cmap,&backcolor)!=0)
    bg=backcolor.pixel;
  else {
    if (pixcolors==NULL) {
      pixcolors=malloc(MAXCOLORS*sizeof(XColor));
      for (i=0;i<MAXCOLORS;i++) 
	pixcolors[i].pixel=(unsigned long)i;
      XQueryColors(GetDisplay(),cmap,pixcolors,MAXCOLORS);
    }
    difference=65535;
    for (i=0;i<MAXCOLORS;i++)
      if ((localdifference=(long)((labs((long)pixcolors[i].red-(long)backcolor.red)+
				   labs((long)pixcolors[i].green-(long)backcolor.green)+
				   labs((long)pixcolors[i].blue-(long)backcolor.blue))/3))
	  <difference) {
	difference=localdifference;
	bg=(unsigned long)i;
      }
  }
  return bg;
}

unsigned long* GetXVColors()
{
  unsigned long* xvp;
  int a;
  xvp=malloc(256*sizeof(unsigned long));
  for (a=0;a<256;a++)
    xvp[a]=GetBestColor(9362*(224&a)/32,9362*(28&a)/4,21845*(3&a));
  return xvp;
}
